<?

class TPLN_DB_Xtra extends TPLN_Error
{

// Xtra
 var $UrlBngTxt;
 var $UrlPrevTxt;
 var $UrlNextTxt;
 var $UrlEndTxt;
 var $NavColorFirst; // couleur pour la navigation
 var $NavColorSecond;
 var $url; // contient les variables
 var $url_var; // contient les options  ajouter
 var $url_attrib; // contient les attributs html  ajouter


// propritaire
 var $NbRecordPerPage; // nombre de rsultats voulues par pages
 var $NbResults; // les rsultats
 var $Count;
 var $First;
 var $Last;
 var $PageNumber;
 var $PageCount;
 var $UrlPrev;
 var $UrlNext;
 var $NavColor;
 var $UrlPageNav; // contient les url de navigation pour les pages


 // constuction de la requete
 function _SetQuery($query)
 {
  $this->query["STRING"] = $query;
  // on parcours la requete  l'envers ;-)'
  // limit ?
  if(preg_match("/LIMIT(.*)/mi",$query,$match))
   {
    $this->query["LIMIT"] = trim($match[1]);
    $query = str_replace($match[0],"",$query); // on remplace ds la chaine
   }

  // order by
  if(preg_match("/ORDER BY(.*)/mi",$query,$match))
   {
    $this->query["ORDER BY"] = trim($match[1]);
    $query = str_replace($match[0],"",$query); // on remplace ds la chaine
   }

  // where
  if(preg_match("/WHERE(.*)/mi",$query,$match))
   {
    $this->query["WHERE"] = trim($match[1]);
    $query = str_replace($match[0],"",$query); // on remplace ds la chaine
   }

   // from
  if(!preg_match("/FROM(.*)/mi",$query,$match))
   {$this->_DBError(4);}

    $this->query["FROM"] = trim($match[1]);
    $query = str_replace($match[0],"",$query); // on remplace ds la chaine


   // select
  if(!preg_match("/SELECT(.*)/mi",$query,$match))
   {$this->_DBError(3);}

    $this->query["SELECT"] = trim($match[1]);
    $query = str_replace($match[0],"",$query); // on remplace ds la chaine
 }

// recr une requete avec les nouveau paramtres de LIMIT ;-)
 function _SetQueryLimit()
 {
  if(empty($this->PageNumber)){$this->PageNumber = 1;}

 // calcul du nombre de pages
 $this->PageCount = ceil($this->Count / $this->NbRecordPerPage); // arrondi a l'entier superieur
 if($this->PageNumber > $this->PageCount){$this->PageNumber = 1;} // erreur


  // on determine debut du limit
  $this->First = ($this->PageNumber - 1) * $this->NbRecordPerPage;
  $this->Last = $this->First + $this->NbRecordPerPage;

  // on reconstruit la requete
 $query = "SELECT ";
 $query .= $this->query["SELECT"];
 $query .= " FROM ";
 $query .= $this->query["FROM"];

 // Where
 if(!empty($this->query["WHERE"]))
   {$query .= " WHERE ";
    $query .= $this->query["WHERE"];}

 // Order By
 if(!empty($this->query["ORDER BY"]))
   {$query .= " ORDER BY ";
    $query .= $this->query["ORDER BY"];}

 // limit
 $query .= " LIMIT  $this->First,$this->NbRecordPerPage";


 //if($this->First == 0){$this->First = 1;}
 $this->First++;
 if($this->Last > $this->Count){$this->Last = $this->Count;}

 return $query;
 }

 // function pour la couleur de la navigation
 function SetNavColor($color1,$color2)
 {
   $this->NavColorFirst = $color1;
   $this->NavColorSecond = $color2;
 }

 // prise totale des rsulats
 function _GetTotalCount()
 {
   $query = "SELECT COUNT(*) ";
   $query .= "FROM ";
   $query .= $this->query["FROM"];

   if(!empty($this->query["WHERE"]))
     {$query .= " WHERE ";
      $query .= $this->query["WHERE"];}

   $this->DoQuery($query);
   $this->Count = $this->GetData('COUNT');
 }


// redefini les variables propriaitaire
 function _ApplyPrivateVar()
 {
   if(empty($this->Url))
    {
      $this->Url = basename($PHP_SELF)."?";
    }


   //if(empty($this->data_item)){return;}

   //if(in_array('_Count',$this->data_item))
   if($this->ItemExists("_Count","data"))
    {$this->Parse("data._Count",$this->Count);}

   //if(in_array('_First',$this->data_item))
   if($this->ItemExists("_First","data"))
    {$this->Parse("data._First",$this->First);}

   //if(in_array('_Last',$this->data_item))
   if($this->ItemExists("_Last","data"))
    {$this->Parse("data._Last",$this->Last);}

   //if(in_array('_PageCount',$this->data_item))
   if($this->ItemExists("_PageCount","data"))
    {$this->Parse("data._PageCount",$this->PageCount);}

   //if(in_array('_PageNumber',$this->data_item))
   if($this->ItemExists("_PageNumber","data"))
    {$this->Parse("data._PageNumber",$this->PageNumber);}


   if(empty($this->url_attrib)){$this->url_attrib = grab_cfg("url_attrib");}

   //if(in_array('_UrlPrev',$this->data_item))
   if($this->ItemExists("_UrlPrev","data"))
    {
     if($this->PageNumber <= $this->PageCount && $this->PageCount != 1 && $this->PageNumber != 1)
      {
       if(empty($this->UrlPrevTxt)){$this->UrlPrevTxt = grab_cfg("prevtxt");}
       $prev_pg = $this->PageNumber - 1;
       $this->Parse("data._UrlPrev","<a href=\"".$this->Url."tpg=$prev_pg".$this->url_var."\"$this->url_attrib>$this->UrlPrevTxt</a>");
      }
     else
      {$this->EraseItem("data._UrlPrev");}
    }


   //if(in_array('_UrlNext',$this->data_item))
   if($this->ItemExists("_UrlNext","data"))
    {
     if($this->PageNumber < $this->PageCount && $this->PageCount != 1)
      {
       if(empty($this->UrlNextTxt)){$this->UrlNextTxt = grab_cfg("nexttxt");}
       $next_pg = $this->PageNumber + 1;
       $this->Parse("data._UrlNext","<a href=\"".$this->Url."tpg=$next_pg".$this->url_var."\"$this->url_attrib>$this->UrlNextTxt</a>");
      }
     else
      {$this->EraseItem("data._UrlNext");}
    }


   //if(in_array('_UrlBng',$this->data_item))
   if($this->ItemExists("_UrlBng","data"))
    {
     if($this->PageCount > 1)
      {
       if(empty($this->UrlBngTxt)){$this->UrlBngTxt = grab_cfg("bngtxt");}
       $first_page = 1;
       $this->Parse("data._UrlBng","<a href=\"".$this->Url."tpg=$first_page".$this->url_var."\"$this->url_attrib>$this->UrlBngTxt</a>");
      }
     else
      {$this->EraseItem("data._UrlBng");}
    }

   //if(in_array('_UrlEnd',$this->data_item))
   if($this->ItemExists("_UrlEnd","data"))
    {
     if($this->PageCount > 1)
      {
       if(empty($this->UrlEndTxt)){$this->UrlEndTxt = grab_cfg("endtxt");}
       $end_page = $this->PageCount;
       $this->Parse("data._UrlEnd","<a href=\"".$this->Url."tpg=$end_page".$this->url_var."\"$this->url_attrib>$this->UrlEndTxt</a>");
      }
     else
      {$this->EraseItem("data._UrlEnd");}
    }

   //if(in_array('_UrlPageNav',$this->data_item))
   if($this->ItemExists("_UrlPageNav","data"))
    {
      $html_attrib = trim(grab_cfg("nav_current_pg_attrib"));

      for($l=1; $l <= $this->PageCount; $l++)
      {
        if($l == $this->PageNumber)
         {$this->UrlPageNav .= "<font $html_attrib>$l</font> ";}
        else
         {$this->UrlPageNav .= "<a href=\"?tpg=$l".$this->url_var."\"$this->url_attrib>$l</a> ";}
      }

      $this->Parse("data._UrlPageNav",$this->UrlPageNav);
    }

    // initialise la navigation
    if(empty($this->NavColorFirst)){$this->NavColorFirst = grab_cfg("nav_color_first");}
    if(empty($this->NavColorSecond)){$this->NavColorSecond = grab_cfg("nav_color_second");}

 }

 //navlabels
 function SetNavLabels($bng_page,$prev_page,$next_page,$end_page)
 {
   if(!empty($bng_page)){$this->UrlBngTxt = $bng_page;}
   if(!empty($prev_page)){$this->UrlPrevTxt = $prev_page;}
   if(!empty($next_page)){$this->UrlNextTxt = $next_page;}
   if(!empty($end_page)){$this->UrlEndTxt = $end_page;}
 }

 // url
 function SetUrl($url)
 {
   $this->Url = $url;
 }

 // urladdvar
 function UrlAddVar($url_add)
 {
  $this->url_var = "&$url_add";
 }

 // url param add
 function AddHtmlUrl($attrib)
 {
  $this->url_attrib = " ".trim($attrib);
 }


 function ShowRecords($query,$nb_result_per_page)
 {
   $this->NbRecordPerPage = $nb_result_per_page;
   $this->PageNumber = $_GET["tpg"]; // variable passe en parametre

   $this->_SetQuery($query); // reconstruit la requete
   $this->_GetTotalCount(); //  nb totl d'enregistrements

   // pas du tout d'enregistrement
   if($this->Count == 0)
    {
     $no_records = $this->GetBlocInFile("data.norecord");
     $this->EraseBloc("data.norecord");
     $this->ParseBloc("data",$no_records);
     return;
    }

   $new_query = $this->_SetQueryLimit(); // requete contenant les limites
   $this->DoQuery($new_query); // execute la requete
   //$results = $this->GetData(); // recupere les rsultats
   $this->NbResults = $this->DbNumRows(); // resultats obtenues != $this->count


   if($this->NbResults == 0)// il y'en a pas pour une recherche
    {
     // a redefinir pour la recherche
     $no_records = $this->GetBlocInFile("data.norecord");
     $this->EraseBloc("data.norecord");
     $this->ParseBloc("data",$no_records);
     return;
    }
   else // si il y a des rsultats alors
    {
      $this->EraseBloc("data.norecord"); // on efface norecord
      $this->_ApplyPrivateVar(); // on modifie les items propriaitaire $Count...
      if(count($this->f_bloc_items[$this->f]["loop"]) == 0){return;}

       // parsing
       while($row = $this->DbFetchAssoc())
        {
          $keys = @array_keys($row);// prise du mon des clefs
          // echo "{$row['User']} {$row['Password']}<br>";
          foreach($keys as $key)
           {
                if($this->ItemExists($key,"loop"))
                {
                   $this->Parse("data.loop.$key",$row["$key"]);
                }

                // ajout de la nav color
                if($this->ItemExists("_NavColor","loop"))
                {
                  $color = ($i % 2) ? $this->NavColorFirst  : $this->NavColorSecond;
                  $this->Parse("data.loop._NavColor",$color);
                }

           }
           $this->Loop("data.loop");
        }
  }
 }
}

// attrape les variables du fichier cfg
function grab_cfg($var)
{
 global $TPLN_DB_HOST_DEFAULT, $TPLN_DB_LOGIN_DEFAULT, $TPLN_DB_PASSWORD_DEFAULT, $TPLN_DB_BASE_DEFAULT,
 $TPLN_DB_UrlBngTxt, $TPLN_DB_UrlPrevTxt, $TPLN_DB_UrlNextTxt, $TPLN_DB_UrlEndTxt, $TPLN_DB_NavColorFirst, $TPLN_DB_NavColorSecond,
 $TPLN_DB_VAR_HTML,$TPLN_DB_NAV_CURRENT_PAGE_HTML;

 if($var == "host"){return $TPLN_DB_HOST_DEFAULT;}
 if($var == "login"){return $TPLN_DB_LOGIN_DEFAULT;}
 if($var == "password"){return $TPLN_DB_PASSWORD_DEFAULT;}
 if($var == "base"){return $TPLN_DB_BASE_DEFAULT;}

 if($var == "bngtxt"){return $TPLN_DB_UrlBngTxt;}
 if($var == "prevtxt"){return $TPLN_DB_UrlPrevTxt;}
 if($var == "nexttxt"){return $TPLN_DB_UrlNextTxt;}
 if($var == "endtxt"){return $TPLN_DB_UrlEndTxt;}

 if($var == "nav_color_first"){return $TPLN_DB_NavColorFirst;}
 if($var == "nav_color_second"){return $TPLN_DB_NavColorSecond;}

 if($var == "url_attrib"){return $TPLN_DB_VAR_HTML;}
 if($var == "nav_current_pg_attrib"){return $TPLN_DB_NAV_CURRENT_PAGE_HTML;}

}



?>