<?

class TPLN_Error extends TPLN_Debug
{
 var $error_msg;
 var $error_signaled = array();


 // Gestiond des erreurs
 function _Error($err_no,$file="",$bloc="",$item="")
 {
   $file_color = "#FF0000";
   $item_color = "#0000FF";
   $bloc_color = "#008000";

  switch($err_no)
    {
         // 0 pas de fichier trouv
         case 0:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "File <font color=\"$file_color\"><b>$file</b></font> not found";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Fichier <font color=\"$file_color\"><b>$file</b></font> non trouv";}
         break;

         // 1 item non trouv
         case 1 :
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Item <font color=\"$item_color\">\{$item}</font> not found in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Item <font color=\"$item_color\">\{$item}</font> non trouv dans le fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

         // 1 item non trouv dans le bloc
         case 1.1 :
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Item <font color=\"$item_color\">\{$item}</font> not found in bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font> of file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Item <font color=\"$item_color\">\{$item}</font> non trouv dans le bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font> du fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

         // 2 bloc inexistant
         case 2:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font> not found in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font> non trouv dans le fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

        // 3 bloc inexistant dans un bloc
         case 3:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font> not found in Bloc <font color=\"$item_color\">\{$item}</font> in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font> non trouv dans le bloc <font color=\"$item_color\">\{$item}</font> du fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

        // 4 chemin du bloc error
        case 4:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Bloc path <font color=\"$item_color\">$bloc</font> in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Chemin du bloc <font color=\"$item_color\">$bloc</font> dans le fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

        // 5 define a bloc
        case 5:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Can't define an empty bloc";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Ne peux dfinir un bloc vide";}
         break;

        // 6 define an item
        case 6:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Can't define an empty item";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Ne peux dfinir un item vide";}
         break;

         // 7 impossible cache directory creation
         case 7:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Can't create cache dir ".TPLN_CACHE_DIR;}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Ne peux crer le rpertoire de cache ".TPLN_CACHE_DIR;}
         break;

         // 8 impossible de trouver la fin du bloc
         case 8:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Can't find end bloc <font color=\"$bloc_color\">$bloc</font> in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Ne peux trouver la fin du bloc  <font color=\"$bloc_color\">$bloc</font> dans le fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

         // 9 le template n'existe pas
         case 9:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Template number $file is not an integer";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Template $file n'est pas un intgral";}
         break;

         // 10 le template n'existe pas
         case 10:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Template number $file doesn't exist";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Template $file n'existe pas";}
         break;

         // 11 le nom du template n'existe pas
         case 11:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Template name $file doesn't defined";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Template $file n'est pas dfini";}
         break;


         // 12 DefineTemplate
         case 12:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "DefineTemplate() must have an array in parameter";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "La fonction DefineTemplate() doit avoir un array en parametre";}
         break;


    }

    $this->error_msg = "<B>Error $err_no:</B> $err_msg";
    $this->_OutPuMessage();
 }

 function _DBError($err_no,$msg="")
 {
   // 0 problem de connexion
   switch($err_no)
    {
        case 0:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Database connection problem ($msg)";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Problme de connexion  la base ($msg)";}
         break;

        // 1 problem de connexion
        case 1:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Database close problem ($msg)";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Problme de fermeture  la base ($msg)";}
        break;

        // 2 problem MySQL !
        case 2:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Query problem ($msg)";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Probleme de requete ($msg)";}
        break;

        // problem dans la construction de la requete
        case 3:
             $err_msg = "SELECT not found in your query";
        break;

        case 4:
             $err_msg = "FROM not found in your query";
        break;
    }

    $this->error_msg = "<B>Db Error:</B> $err_msg";
    $this->_OutPuMessage();
 }

// ben alert par email de l'admin
 function _MailAlert()
 {
  if($this->debug_mode == 1){return;}  // pas de messge d'erreur en mode debug

  $err_alert = TPLN_ERROR_ALERT;
  $mail_admin = TPLN_MAIL_ADMIN;

   if(($err_alert == 1) && (!empty($mail_admin)) && $_GET["tpln_w"] != "adm")
   {
    $request_url_simple = str_replace("?".$_SERVER["QUERY_STRING"],"",$_SERVER["REQUEST_URI"]);
    $url = "http://".$_SERVER["HTTP_HOST"].$request_url_simple."?tpln_w=adm";

    $subject = "[TPLN] Alert Error";

    $body = date("[Y-m-d H:i] ")." TPLN has detected an error\n\n";
    $body .= strip_tags($this->error_msg)." in ".$_SERVER["SCRIPT_FILENAME"]."\n\n\n";
    $body .= "Url $url\n";
    $body .= "===========================================\n";
    $body .= "TPLN version 1.2\n";
    $body .= "http://tpln.sourceforge.net";

    $from = "From: TPLN<".TPLN_MAIL_EXPEDITOR.">\n";
    $from .= "X-Mailer: PHP/". phpversion();


        if(@mail(TPLN_MAIL_ADMIN,$subject,$body,$from))
         {
           if(TPLN_ERROR_LANG == "en"){$msg = "<br><br><hr>An email has been sent to the webmaster <a href=\"mailto:$mail_admin\">$mail_admin</a>";}
           if(TPLN_ERROR_LANG == "fr"){$msg = "<br><br><hr>Un Email a t envoy au webmaster <a href=\"mailto:$mail_admin\">$mail_admin</a>";}

           $this->error_msg .= $msg;
         }

   }

 }

// pour la sortie du message
function _OutPuMessage()
 {
   $this->_MailAlert();

   if(!@in_array($this->error_msg,$this->error_signaled))
    {
     echo $this->error_msg;
     echo "<br>\n";
     $this->error_signaled[] = $this->error_msg;
    }

   if($this->struct_mode == 0 && $this->trace_mode == 0)
    {
      exit();
    }
 }

}

?>